'*******************************************************************************
'
'                            SSD1289 LCD Test
'
'                            resolution 240x320
'
'*******************************************************************************

$regfile = "m2560def.dat"
$crystal = 16000000
$hwstack = 256
$swstack = 256
$framesize = 256

'--------------------------- Pin Configuration ---------------------------------

  Data_disp_low Alias Portc : Config Data_disp_low = Output 'DB0 - DB7
  Data_disp_high Alias Porta : Config Data_disp_high = Output       'DB8 - DB15
  Rs_disp Alias Portd.7 : Config Rs_disp = Output           'Command/Data pin
  Wr_disp Alias Portg.2 : Config Wr_disp = Output           'Write pin
  Res_disp Alias Portg.0 : Config Res_disp = Output         'Reset pin
  Res_disp = 1

  Cs_disp Alias Portg.1 : Config Cs_disp = Output : Cs_disp = 0

'-------------------------------- Library --------------------------------------
Const Portrait = 1                                          '0=Landscape, 1=Portrait

Config Submode = New : $include "SSD1289 16bit library.inc" 'Include library

'------------------------------- TouchScreen -----------------------------------
Clk_touch Alias Porth.3 : Config Clk_touch = Output         'XPT2046 Clock Pin
Cs_touch Alias Porte.3 : Config Cs_touch = Output           'XPT2046 CS Pin
Dout_touch Alias Portg.5 : Config Dout_touch = Output       'XPT2046 Din Pin
Din_touch Alias Pine.5 : Config Din_touch = Input           'XPT2046 Dout Pin
Cs_touch = 1

Config Pine.4 = Input : Porte.4 = 1                         'Pen Interrupt
Config Int4 = Falling
On Int4 Touch_int
Enable Int4

Dim Touch_flag As Bit
Dim Touchx As Word , Touchy As Word
Dim X_dout As Byte : X_dout = 212                           '208
Dim Y_dout As Byte : Y_dout = 148                           '144
$include "Touch.inc"
'-------------------------------------------------------------------------------

Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1
Spsr.0 = 1 : Spcr.0 = 0 : Spcr.1 = 0                        'F_spi = F_osc / 2
Ss_spi_rom Alias Portb.0 : Config Ss_spi_rom = Output : Ss_spi_rom = 1       'Chip Select pin
Spiinit



'-------------------------------------------------------------------------------
Sub Pause()
Waitms 100
End Sub

'================================ Test Program =================================

Dim Count As Word , Text As String * 16 , N As Word , M As Word , B As Byte

Enable Interrupts
Display_init                                                ' Initialize Display

'-------------------------RL------TB-----------433F
'Ssd1289_write_reg 1 , &B0_1_10_10_1_1_0011_1111             'H293F                                'Not Rotated

'Ssd1289_write_reg 17 , &B0110_0000_01_11_0_000              'H6078                               'Entry Mode


'Do




Lcd_clear Steelblue                                         'Gray

'Lcd_set_pixel 0 , 0 , Red
'Restore Font25x32
'Lcd_text "7" , 0 , 0 , Black , 50712
'Pause
'Loop
Lcd_pic_spi 0 , 0 , 240 , 320 , 46560                       'Load background
Restore Font25x32
'Lcd_text "7" , 0 , 0 , Black , 50712

Do

If Touch_flag = 1 Then
   Read_touch

   If Touchx > 11 And Touchx < 46 Then
      If Touchy > 139 And Touchy < 166 Then                 'Ce
         Lcd_text " Ce" , 140 , 58 , Black , 50712
         Lcd_pic_spi 0 , 127 , 60 , 37 , 200160
         Pause
         Lcd_pic_spi 0 , 127 , 60 , 37 , 292800
      End If

      If Touchy > 179 And Touchy < 203 Then                 '7
         Lcd_text "  7" , 140 , 58 , Black , 50712
         Lcd_pic_spi 0 , 164 , 60 , 39 , 32520
         Pause
         Lcd_pic_spi 0 , 164 , 60 , 39 , 278760
      End If

      If Touchy > 214 And Touchy < 245 Then                 '4
         Lcd_text "  4" , 140 , 58 , Black , 50712
         Lcd_pic_spi 0 , 203 , 60 , 37 , 18480
         Pause
         Lcd_pic_spi 0 , 203 , 60 , 37 , 264720
      End If

      If Touchy > 259 And Touchy < 277 Then                 '1
         Lcd_text "  1" , 140 , 58 , Black , 50712
         Lcd_pic_spi 0 , 242 , 60 , 38 , 4800
         Pause
         Lcd_pic_spi 0 , 242 , 60 , 38 , 251040
      End If

      If Touchy > 294 And Touchy < 316 Then                 '0
         Lcd_text "  0" , 140 , 58 , Black , 50712
         Lcd_pic_spi 0 , 280 , 60 , 40 , 0
         Pause
         Lcd_pic_spi 0 , 280 , 60 , 40 , 246240
      End If
   End If

   If Touchx > 70 And Touchx < 110 Then
      If Touchy > 139 And Touchy < 166 Then                 'Off
         Lcd_text "Off" , 140 , 58 , Black , 50712
         Lcd_pic_spi 60 , 127 , 60 , 37 , 218640
         Pause
         Lcd_pic_spi 60 , 127 , 60 , 37 , 311280
      End If

      If Touchy > 179 And Touchy < 203 Then                 '8
         Lcd_text "  8" , 140 , 58 , Black , 50712
         Lcd_pic_spi 60 , 164 , 60 , 39 , 37200
         Pause
         Lcd_pic_spi 60 , 164 , 60 , 39 , 283440
      End If

      If Touchy > 214 And Touchy < 245 Then                 '5
         Lcd_text "  5" , 140 , 58 , Black , 50712
         Lcd_pic_spi 60 , 203 , 60 , 37 , 23160
         Pause
         Lcd_pic_spi 60 , 203 , 60 , 37 , 269400
      End If

      If Touchy > 259 And Touchy < 277 Then                 '2
         Lcd_text "  2" , 140 , 58 , Black , 50712
         Lcd_pic_spi 60 , 242 , 60 , 38 , 9360
         Pause
         Lcd_pic_spi 60 , 242 , 60 , 38 , 255600
      End If

      If Touchy > 294 And Touchy < 316 Then                 'Dot
         Lcd_text "  ." , 140 , 58 , Black , 50712
         Lcd_pic_spi 60 , 280 , 60 , 40 , 209040
         Pause
         Lcd_pic_spi 60 , 280 , 60 , 40 , 301680
      End If
   End If

   If Touchx > 130 And Touchx < 170 Then
      If Touchy > 139 And Touchy < 166 Then                 'Square
         Lcd_text "Sqr" , 140 , 58 , Black , 50712
         Lcd_pic_spi 120 , 127 , 60 , 37 , 232440
         Pause
         Lcd_pic_spi 120 , 127 , 60 , 37 , 325080
      End If

      If Touchy > 179 And Touchy < 203 Then                 '9
         Lcd_text "  9" , 140 , 58 , Black , 50712
         Lcd_pic_spi 120 , 164 , 60 , 39 , 41880
         Pause
         Lcd_pic_spi 120 , 164 , 60 , 39 , 288120
      End If

      If Touchy > 214 And Touchy < 245 Then                 '6
         Lcd_text "  6" , 140 , 58 , Black , 50712
         Lcd_pic_spi 120 , 203 , 60 , 37 , 27840
         Pause
         Lcd_pic_spi 120 , 203 , 60 , 37 , 274080
      End If

      If Touchy > 259 And Touchy < 277 Then                 '3
         Lcd_text "  3" , 140 , 58 , Black , 50712
         Lcd_pic_spi 120 , 242 , 60 , 38 , 13920
         Pause
         Lcd_pic_spi 120 , 242 , 60 , 38 , 260160
      End If

      If Touchy > 294 And Touchy < 316 Then                 'Equal
         Lcd_text "  =" , 140 , 58 , Black , 50712
         Lcd_pic_spi 120 , 280 , 60 , 40 , 213840
         Pause
         Lcd_pic_spi 120 , 280 , 60 , 40 , 306480
      End If
   End If


   If Touchx > 190 And Touchx < 230 Then
      If Touchy > 139 And Touchy < 166 Then                 'Divide
         Lcd_text "  /" , 140 , 58 , Black , 50712
         Lcd_pic_spi 180 , 127 , 60 , 37 , 204600
         Pause
         Lcd_pic_spi 180 , 127 , 60 , 37 , 297240
      End If

      If Touchy > 179 And Touchy < 203 Then                 'X
         Lcd_text "  X" , 140 , 58 , Black , 50712
         Lcd_pic_spi 180 , 164 , 60 , 39 , 236880
         Pause
         Lcd_pic_spi 180 , 164 , 60 , 39 , 329520
      End If

      If Touchy > 214 And Touchy < 245 Then                 '-
         Lcd_text "  -" , 140 , 58 , Black , 50712
         Lcd_pic_spi 180 , 203 , 60 , 37 , 241560
         Pause
         Lcd_pic_spi 180 , 203 , 60 , 37 , 334200
      End If

      If Touchy > 259 And Touchy < 316 Then                 '+
         Lcd_text "  +" , 140 , 58 , Black , 50712
         Lcd_pic_spi 180 , 242 , 60 , 78 , 223080
         Pause
         Lcd_pic_spi 180 , 242 , 60 , 78 , 315720
      End If
   End If


   Touch_flag = 0
End If

Loop

End                                                         'end program
'-------------------------------------------------------------------------------
$include "Font25x32.font"

'---------------- Touch Interrupt
Touch_int:
    Touch_flag = 1
Return